Subject: Name constraints on last cert

From: 박용학 <[email-masked]>
Date: Thu, 21 Jun 2001 17:46:46 +0900

Hi all.

I've been looking over the new draft and find that name constraints are now
applied to the last certificate in the path even in the case of a self-issued
certificate. I understand that there is a need to block the validation of a
certificate which has 'new' alternative names that do not fit the name constraints
imposed by CAs which reside higher in the path. But I also think that if the final
certificate is self-issued, it should be allowed the names that were recognized
by the direct neighbouring CA.

Considering the following chain of 2 certificates:

Certificate 1:
 Issuer:  o=trusty, c=us
 Subject: o=shady, c=us
 SubjectAltName:
  rfc822Name: [email-masked]
 Basic Constraints:
  cA=true
 Name Constraints:
  Permitted:
   directoryName: o=shady, c=us
   rfc822Name: .shady.com

Certificate 2:
 Issuer:  o=shady, c=us
 Subject: o=shady, c=us
 SubjectAltNames:
  rfc822Name: [email-masked]	

It would seem right that Certificate 2 is perfectly valid (be it a key changeover
certificate or something else). But according to the current draft, this will fail
the path validation, even though certificates that it issues with the new key
(supposing that it was a key changeover certificate) will be validated as long
as they are issued by the subject name.

It seems to me by the way the draft has been changing, that CAs are now
allowed to have certs for jobs other than signing certs and CRLs. Systems
will probably want to validate these certs. If the CA name is outside of
the name scope of the direct neighbouring CA( which is perfectly OK,
or we wouldn't skip self-issued certs that aren't at the end of the path),
none of these certificates will be validated. I think this will get to be a
big problem.

Am I thinking wrong?

Albert Park